﻿using System;
using System.ComponentModel;

namespace ManagedCode
{
	public static class Class2
	{

		[Description("Event brief description")]
		public static event EventHandler OnMessage = delegate { };

		[Description("Property brief description")]
		public static string Message { get; set; }

		/// <summary>
		/// Method brief description
		/// </summary>
		/// <returns>the default message</returns>
		public static string Hello()
		{
			return "Hello Managed Code!";
		}

		/// <summary>
		/// Method brief description
		/// </summary>
		/// <param name="message">the message to set</param>
		public static void SetMessage(string message)
		{
			Message = message;
			OnMessage(null, EventArgs.Empty);
		}
	}

	public class Class1
	{
		[Description("Default constructror without parameters")]
		public Class1()
		{
			this.Message = "HiAsm.NET!";
		}

		[Description("Constructror with a single parameter")]
		public Class1(string message)
		{
			this.Message = message;
		}

		[Description("Constructror with the two parameters")]
		public Class1(string message, int count)
		{
			this.Message = message;
			this.Count = count;
		}

		[Description("Event brief description")]
		public event EventHandler OnMessage = delegate{};

		[Description("Property brief description")]
		public string Message { get; set; }

		[Description("Property brief description")]
		public int Count { get; }

		/// <summary>
		/// Method brief description
		/// </summary>
		/// <returns>the default message</returns>
		public string Hello()
		{
			return "Hello Managed Code!";
		}
		/// <summary>
		/// Method brief description
		/// </summary>
		/// <param name="message">the message to set</param>
		public void SetMessage(string message)
		{
			this.Message = message;
			OnMessage(this, EventArgs.Empty);
		}
    }
}
